=== debian/changelog ===
direwolf (1.6+dfsg-2) unstable; urgency=medium

  [ Daniele Forsi ]
  * Put link to online PDF documentation in man pages and fix link
    in --help output.
  * Fix/override Lintian warnings and lintian-brush warnings.

  [ Christoph Berg ]
  * Restrict again to linux-any. In theory other OSes are supported via
    liboss4-salsa-dev but that is lacking snd_pcm_recover so don't bother
    porting for now.
  * Fix GitHub watch file.

 -- Christoph Berg <myon@debian.org>  Wed, 05 Jan 2022 11:07:20 +0100

direwolf (1.6+dfsg-1) unstable; urgency=medium

  * New upstream version, buildsystem switched to cmake.
  * Revert to Architecture: any, big endian is supported now.
  * B-D on libudev-dev [linux-any].
  * Add debian/gitlab-ci.yml.
  * Adopt package from Ian, thanks! (Closes: #970374)

 -- Christoph Berg <myon@debian.org>  Sun, 03 Jan 2021 22:14:07 +0100

direwolf (1.5+dfsg-5) unstable; urgency=medium

  [ Debian Janitor ]
  * Set debhelper-compat version in Build-Depends.
  * Set upstream metadata fields: Bug-Database.

  [ Iain R. Learmonth ]
  * Adds additional little-endian architectures (Fixes: #945297)
  * Install kissutil (Fixes: #954431)

 -- Iain R. Learmonth <irl@debian.org>  Mon, 14 Sep 2020 13:45:57 +0100
