=== debian/watch ===
version=4
opts=dversionmangle=s/.dfsg//,repacksuffix=+dfsg \
https://github.com/wb2osz/direwolf/tags .*/v?(\d[\d.-]+)\.(?:tar(?:\.gz|\.bz2)?|tgz)
